/*
 * action.c
 */

__asm("	text\n	dc.b	'$Id: action.c,v 1.13 1998/10/13 00:02:54 sharl Exp $'\n	even\n");

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#define __IOCS_INLINE__
#include <iocslib.h>

#include "config.h"
#include "action.h"
#include "channel.h"
#include "util.h"
#include "kanji.h"

BOOLEAN show_namreply = TRUE;
int names_num = 0;

/****************************************
	oper s  1
****************************************/
void
auto_oper1(int sock, char *buf)
{
	int n;
	char **op, *np;
	CHANSTAT *csp;
	char chan[512], chanbuf[512];

	np = xmalloc(strlen(irc_nick) + 1 /* '@' */  + 1);
	sscanf(buf, "%*s %s :%n", chan, &n);
	jchan2sjchan(chanbuf, chan);
	if (show_namreply)
		printf("%s \033[31m*** %s: %s\033[m\n", getnow(), chanbuf, buf + n);
	*np = '@';
	strcpy(np + 1, irc_nick);

	if ((csp = getchanstat(chanbuf)) != NULL) {
		char **w, **whoisjoin;

		div_string(buf + n, &whoisjoin);
		/*  oper ǂ */
		for (w = whoisjoin; *w; w++) {
			if (!strcasecmp(*w, np))
				csp->isoper = TRUE;
		}

		/* ȂƔz蔻 */
		if (csp->isoper && irc_autochanops) {
			for (op = irc_autochanop; *op; op++) {
				for (w = whoisjoin; *w; w++) {
					if (**w != '@' && !strncasecmp(*w, *op, strlen(*op))) {
						char line[1024];

						sprintf(line, "MODE %s +o %s\r\n", chan, *w);
#ifdef DEBUG
						if (debug)
							printf(line);
#endif
						write(sock, line, strlen(line));
					}
				}
			}
		}
		for (w = whoisjoin; *w; w++)
			free(*w);
		free(whoisjoin);
	}
	free(np);
}

/****************************************
	oper s  2

	AUTO-CHANOP Ȃⓚp +o 
	chan: SJIS
****************************************/
void
auto_oper2(int sock, char *chan, char *nick)
{
	CHANSTAT *csp;
	char **op, chanbuf[512];

	csp = getchanstat(chan);
	if (csp && csp->isoper) {
		sjchan2jchan(chanbuf, chan);
		for (op = irc_autochanop; *op; op++) {
			if (!strncasecmp(nick, *op, strlen(*op))) {
				char line[1024];

				sprintf(line, "MODE %s +o %s\r\n", chanbuf, nick);
#ifdef DEBUG
				if (debug)
					printf(line);
#endif
				write(sock, line, strlen(line));
			}
		}
	}
}

/****************************************
	ڑĂ邩ǂׂ
****************************************/
void
notify(char *buf)
{
	char **p, **w, **whoison;
	int c;

	if (div_string(buf + 1, &whoison) == 0) {
		ison = FALSE;
		return;
	}
	for (w = whoison; *w; w++) {
		if (**w == '\r' || **w == '\n')
			continue;
		for (c = 0, p = irc_ison; *p; c++, p++) {
			if (ison_list[c].on == FALSE
				&& !strcasecmp(ison_list[c].name, *w)) {
				ison_list[c].on = TRUE;
				if (ison_bell)
					_iocs_adpcmout(ison_bell, 0x0403 /* 15.6KHz, stereo */,
								   ison_bell_length);
				else
					putchar('\a');
				printf("%s \033[31m%s is ON\033[m\n",
					   getnow(), ison_list[c].name);
			}
		}
	}
	for (c = 0, p = irc_ison; *p; c++, p++) {
		if (!strcasestr(buf + 1, ison_list[c].name)
			&& ison_list[c].on == TRUE) {
			ison_list[c].on = FALSE;
			printf("%s \033[31m%s is OFF\033[m\n",
				   getnow(), ison_list[c].name);
		}
	}
	for (w = whoison; *w; w++)
		free(*w);
	free(whoison);
	ison = FALSE;
}

/****************************************
	MODE ωł̑Ή

	chan: JIS
****************************************/
void
apply_mode(int sock, char *chan)
{
	char linebuf[BUFSIZ];

	sprintf(linebuf, "NAMES %s\r\n", chan);
#ifdef DEBUG
	if (debug)
		printf(linebuf);
#endif
	write(sock, linebuf, strlen(linebuf));
	show_namreply = FALSE;
	names_num++;
}

/****************************************
	AWAY ̏Ԃ nick ω
****************************************/
static char *original_nick = NULL;

static void
change_nick(int sock)
{
	char buf[256];

	sprintf(buf, "NICK %s\r\n", irc_nick);
#ifdef DEBUG
	if (debug)
		puts(buf);
#endif
	write(sock, buf, strlen(buf));
}

void
unaway(int sock, char *nick)
{
	if (original_nick && strcasecmp(original_nick, nick)) {
		irc_nick = original_nick;
		change_nick(sock);
	}
}

void
nowaway(int sock, char *nick)
{
	original_nick = irc_nick;
	irc_nick = irc_awaynick;
	change_nick(sock);
}

/****************************************
	nick ωł̑Ή
****************************************/
void
apply_nick(int sock, char *oldnick, char *newnick)
{
	CHANSTAT *csp;

	if (!strcmp(oldnick, irc_nick)) {
		irc_nick = xrealloc(irc_nick, strlen(newnick) + 1);
		strcpy(irc_nick, newnick);
	} else {
		int i;

		show_namreply = FALSE;
		for (i = 0; i < IRC_JOIN_MAX; i++) {
			csp = &chanlist[i];
			if (csp->active && (*csp->name == '#' || *csp->name == '&' || *csp->name == '%')) {
				char line[1024], chan[512];

				sjchan2jchan(chan, csp->name);
				sprintf(line, "NAMES %s\r\n", chan);
#ifdef DEBUG
				if (debug)
					printf(line);
#endif
				write(sock, line, strlen(line));
				names_num++;
			}
		}
	}
	/* priv channel Ǐ] */
	csp = getchanstat(oldnick);
	if (csp) {
		csp->name = xrealloc(csp->name, strlen(newnick) + 1);
		strcpy(csp->name, newnick);
	}
}

/****************************************
	kick ł̑Ή

	chan: JIS
	rest: JIS
****************************************/
void
apply_kick(int sock, char *nick, char *chan, char *rest)
{
	char chanbuf[512], newbuf[512];
	char whom[512], reason[512];

	sscanf(rest, "%s :%[^\r\n]", whom, reason);
	jchan2sjchan(chanbuf, chan);
	jstr2sjstr(newbuf, reason);
	if (!strcasecmp(irc_nick, whom)) {
		printf("%s \033[31m*** You were kicked off %s by %s (%s)\033[m\n",
			   getnow(), chanbuf, nick, newbuf);
		part_chanlist(chanbuf);
		if (irc_autorejoin) {
			char line[1024];

			sprintf(line, "JOIN %s\r\n", chan);
			write(sock, line, strlen(line));
		}
	} else {
		printf("%s \033[31m*** %s has kicked %s out from %s (%s)\033[m\n",
			   getnow(), nick, whom, chanbuf, newbuf);
	}
}
