/*
 * channel.c
 */

__asm("	text\n	dc.b	'$Id: channel.c,v 1.12 1998/09/27 03:58:29 sharl Exp $'\n	even\n");

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#include "config.h"
#include "kanji.h"
#include "channel.h"
#include "util.h"

BOOLEAN nojoin = FALSE;
int current_channel = -1;	/*  active ȃ`lԍ */

CHANSTAT chanlist[IRC_JOIN_MAX];

/****************************************
	w肳ꂽ`l̏ԂԂ
	啶͓ꎋ
****************************************/
CHANSTAT *
getchanstat(char *chan)
{
	int i;
	char chanbuf1[512], chanbuf2[512];

	for (i = 0; i < IRC_JOIN_MAX; i++) {
		if (chanlist[i].active) {
			sjchan2jchan(chanbuf1, chanlist[i].name);
			sjchan2jchan(chanbuf2, chan);
			if (!strcasecmp(chanbuf1, chanbuf2))
				return &chanlist[i];
		}
	}
	return NULL;
}

/****************************************
	V`lɐ؂ւ
****************************************/
void
new_channel(int old)
{
	int i;

	for (i = old + 1; i < IRC_JOIN_MAX; i++) {
		if (chanlist[i].active != FALSE) {
			current_channel = i;
			return;
		}
	}
	for (i = 0; i <= old; i++) {
		if (chanlist[i].active != FALSE) {
			current_channel = i;
			return;
		}
	}
	current_channel = -1;
}

/****************************************
	`lXg TOPIC o^
****************************************/
void
set_topic(char *chan, char *topic)
{
	CHANSTAT *cp;

	if ((cp = getchanstat(chan)) != NULL) {
		cp->topic = xrealloc(cp->topic, strlen(topic) + 1);
		strcpy(cp->topic, topic);
	}
}

/****************************************
	SJIS `l IRC `lɕϊ
****************************************/
void
sjchan2jchan(char *dst, const unsigned char *src)
{
#if 0
	unsigned char buf[512];

	if (*src == '%') {
		*buf = '#';
		strcpy(buf + 1, src + 1);
		strcat(buf, ":");
		strcat(buf, irc_channel_mask);
		sjstr2jstr(dst, buf);
		return;
	} else
#endif
	sjstr2jstr(dst, src);
}

/****************************************
	IRC `l SJIS `lɕϊ
****************************************/
void
jchan2sjchan(unsigned char *dst, const char *src)
{
#if 0
	size_t s;
	unsigned char buf[512];

	s = strlen(src) - (strlen(irc_channel_mask) + 1 /* ':' */);
	if (s > 0 && *(src + s) == ':' && !strcmp(src + s + 1, irc_channel_mask)) {
		*buf = '%';
		strncpy(buf + 1, src + 1, s - 1);
		*(buf + s) = '\0';
		jstr2sjstr(dst, buf);
		return;
	}
#endif
	jstr2sjstr(dst, src);
}

/****************************************
	ݒ肳ꂽ`l JOIN
****************************************/
void
irc_initial_join(int sock)
{
	int i;
	char buf[BUFSIZ];
	char linebuf[BUFSIZ];

	for (i = 0; i < IRC_JOIN_MAX; i++) {
		chanlist[i].active = FALSE;
		chanlist[i].name = NULL;
		chanlist[i].topic = NULL;
		chanlist[i].isoper = FALSE;
		chanlist[i].donemodewithjoined = FALSE;
	}

	if (nojoin)
		return;
	for (i = 0; i < IRC_JOIN_MAX && irc_channel[i].name; i++) {
		sjchan2jchan(buf, irc_channel[i].name);
		if (irc_channel[i].key)
			sprintf(linebuf, "JOIN %s %s\r\n", buf, irc_channel[i].key);
		else
			sprintf(linebuf, "JOIN %s\r\n", buf);
#ifdef DEBUG
		if (debug)
			fprintf(stderr, linebuf);
#endif
		write(sock, linebuf, strlen(linebuf));
	}
}

/****************************************
	JOIN
****************************************/
void
join_chanlist(const char *chan, BOOLEAN change)
{
	int i, count = 0;

	for (i = 0; i < IRC_JOIN_MAX; i++)
		if (chanlist[i].active)
			count++;

	for (i = 0; i < IRC_JOIN_MAX; i++) {
		if (chanlist[i].active == FALSE) {
			if (change || !count)
				current_channel = i;
			chanlist[i].active = TRUE;
			chanlist[i].name = xstrdup(chan);
			return;
		}
	}
}

/****************************************
	PART
****************************************/
void
part_chanlist(const char *chan)
{
	int i;

	for (i = 0; i < IRC_JOIN_MAX; i++) {
		CHANSTAT *p = &chanlist[i];

		if (p->active != FALSE && !strcmp(p->name, chan)) {
			p->active = FALSE;
			free(p->name);
			p->name = NULL;
			if (p->topic) {
				free(p->topic);
				p->topic = NULL;
			}
			p->isoper = FALSE;
			p->donemodewithjoined = FALSE;
			if (i == current_channel)
				new_channel(current_channel);
			return;
		}
	}
}

/****************************************
	w肳ꂽ`lɐ؂ւ
****************************************/
void
change_channel(const char *chan)
{
	int i;

	for (i = 0; i < IRC_JOIN_MAX; i++) {
		if (chanlist[i].active != FALSE && !strcasecmp(chanlist[i].name, chan)) {
			current_channel = i;
			return;
		}
	}
}

/****************************************
	list JOINed channel
****************************************/
void
list_joined()
{
	int i;

	for (i = 0; i < IRC_JOIN_MAX; i++)
		if (chanlist[i].active)
			printf("%d %s\n", i, chanlist[i].name);
}
