/*
 * command.c
 */

__asm("	text\n	dc.b	'$Id: command.c,v 1.27 1998/10/17 17:28:28 sharl Exp $'\n	even\n");

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>

#include "config.h"
#include "ctcp.h"
#include "command.h"
#include "channel.h"
#include "util.h"
#include "kanji.h"

time_t irc_ping;	/* ping time */
int ping_code;

BOOLEAN explicitly_quit = FALSE;

/****************************************
	݂̃`l NAMES s
****************************************/
void
irc_names(int sock)
{
	char buf[BUFSIZ];
	char chanbuf[BUFSIZ];

	if (current_channel < 0)
		return;

	sjchan2jchan(chanbuf, chanlist[current_channel].name);
	if (*chanbuf != '#' && *chanbuf != '&')
		return;
	sprintf(buf, "NAMES %s\r\n", chanbuf);
#ifdef DEBUG
	if (debug)
		printf(buf);
#endif
	write(sock, buf, strlen(buf));
}

/****************************************
	I
****************************************/
void
irc_quit(int sock, char *msg)
{
	char linebuf[1024];
	char newbuf[1024];

	sjstr2jstr(newbuf, msg);
	sprintf(linebuf, "QUIT :%s\r\n", newbuf);
#ifdef DEBUG
	if (debug)
		printf(linebuf);
#endif
	write(sock, linebuf, strlen(linebuf));
	explicitly_quit = TRUE;
}

/****************************************
	IRC R}h
****************************************/
void
irc_command(int sock, char *buf)
{
	char linebuf[1024];
	char newbuf[1024];
	char chan[512], chanbuf[512];

	if (!strncasecmp(buf, "join", 4)) {
		//
		// join
		//
		int i, joined = 0;
		char **chanp, **cp;

		for (i = 0; i < IRC_JOIN_MAX; i++)
			if (chanlist[i].active != FALSE)
				joined++;
		if (joined == IRC_JOIN_MAX) {
			printf("%s \033[32mYou are already joined %d channel\033[m\n", getnow(), IRC_JOIN_MAX);
			return;
		}
		div_string(skipspace(buf + 4 /* strlen("join") */), &chanp);
		for (cp = chanp; *cp; cp++) {
			char *key;

			key = strchr(*cp, ',');
			if (key)
				*key = '\0';
			strcpy(chan, *cp);

			if (*chan != '#' && *chan != '&' && *chan != '%') {	/* ΌlȂ */
				CHANSTAT *csp = getchanstat(chan);

				printf("%s \033[35mYou are talking to %s\033[m\n", getnow(), chan);
				if (!csp)
					join_chanlist(chan, TRUE);
				else
					change_channel(chan);
				if (irc_priv_whois) {
					sprintf(linebuf, "WHOIS %s\r\n", chan);
#ifdef DEBUG
					if (debug)
						printf(linebuf);
#endif
					write(sock, linebuf, strlen(linebuf));
				}
				return;
			}
			sjchan2jchan(chanbuf, chan);
			if (key)
				sprintf(linebuf, "JOIN %s %s\r\n", chanbuf, key + 1);
			else
				sprintf(linebuf, "JOIN %s\r\n", chanbuf);
#ifdef DEBUG
			if (debug)
				printf(linebuf);
#endif
			write(sock, linebuf, strlen(linebuf));
		}
		for (cp = chanp; *cp; cp++)
			free(*cp);
		free(chanp);
		return;
	} else if (!strncasecmp(buf, "part", 4)) {
		//
		// part
		//
		if (current_channel < 0)
			return;
		sscanf(buf, "%*s %s", chan);
		if (*chan != '#' && *chan != '&' && *chan != '%') {	/* ΌlȂ */
			part_chanlist(chan);
			return;
		}
		sjchan2jchan(chanbuf, chan);
		sprintf(linebuf, "PART %s\r\n", chanbuf);
#ifdef DEBUG
		if (debug)
			printf(linebuf);
#endif
		write(sock, linebuf, strlen(linebuf));
		return;
	} else if (!strncasecmp(buf, "nick", 4)) {
		//
		// nick
		//
		sscanf(buf, "%*s %s", newbuf);
		sprintf(linebuf, "NICK %s\r\n", newbuf);
		write(sock, linebuf, strlen(linebuf));
		return;
	} else if (!strncasecmp(buf, "privmsg", 7)) {
		//
		// privmsg
		//
		sscanf(buf, "%*s %s %s", chanbuf, newbuf);
		printf(*chanbuf == '#' || *chanbuf == '&' || *chanbuf == '%'
			   ? "%s >%s:%s< %s\n"
			   : "%s =%s:%s= %s\n",
			   getnow(), chanbuf, irc_nick, newbuf);
		/* THROUGH */
	} else if (!strncasecmp(buf, "ignore", 6)) {
		//
		// ignore
		//
		char **ign, **ignnicks = NULL;

		div_string(buf, &ignnicks);
		if ((ign = ignnicks) != NULL) {
			ign++;	// 'ignore' skip
			if (!*ign)
				goto show;

			for (; *ign; ign++) {
				if (!irc_ignore)
					init_ignore(*ign);
				else
					mod_ignore(*ign);
			}

			for (ign = ignnicks; *ign; ign++)
				free(*ign);
			free(ignnicks);
		}
	show:
		list_ignore();
		return;
	} else if (!strncasecmp(buf, "show", 4)) {
		//
		// show
		//
		char **p;

		printf("server         : %s\n", irc_server);
		printf("nick           : %s\n", irc_nick);
		printf("mail           : %s\n", irc_user);
		printf("name           : %s\n", irc_name);
		printf("userinfo       : %s\n", irc_info);
		printf("quit message   : %s\n", irc_quit_message);
		if (irc_timeout > 0)
			printf("timeout        : %d\n", irc_timeout);
		printf("aquit message  : %s\n", irc_autoquit_message);
		printf("keyword        : %s, %s, %s\n",
			   irc_keyword,
			   irc_keyword_bell ? : "BEEP",
			   irc_keyword_bold ? "BOLD" : "NOBOLD"
			  );
		printf("auto operator  :");
		if (irc_autochanops)
			for (p = irc_autochanop; *p; p++)
				printf(" %s", *p);
		printf("\nnotify         :");
		if (irc_isons)
			for (p = irc_ison; *p; p++)
				printf(" %s", *p);
		printf("\nnotify interval: %d", irc_ison_interval);
		if (irc_ignore) {
			IGNORE *ip;

			printf("\nignore         :");
			for (ip = irc_ignore; ip; ip = ip->next)
				if (ip->on)
					printf(" %s", ip->nick);
		}
		printf("\nauto join      : %s\n", irc_autojoin ? "TRUE" : "FALSE");
		printf("auto reconnect : %s\n", irc_autoreconnect ? "TRUE" : "FALSE");
		printf("auto rejoin    : %s\n", irc_autorejoin ? "TRUE" : "FALSE");
		return;
	} else if (!strncasecmp(buf, "timeout", 7)) {
		//
		// timeout
		//
		time_t t = 0;

		sscanf(buf, "%*s %d\n", &t);
		if (t) {
			irc_timeout = t;
			printf("%s \033[32minactive timeout = %d second\033[m\n", getnow(), irc_timeout);
		}
		return;
	} else if (!strncasecmp(buf, "ctcp", 4)) {
		//
		// ctcp
		//
		ctcp_to(sock, buf);
		return;
	} else if (!strncasecmp(buf, "userinfo", 8)) {
		//
		// userinfo
		//
		*newbuf = '\0';
		sscanf(buf, "%*s %s", newbuf);
		if (*newbuf) {
			irc_info = xrealloc(irc_info, strlen(newbuf) + 1);
			strcpy(irc_info, newbuf);
		}
		printf("%s \033[32muserinfo set '%s'\033[m\n", getnow(), irc_info);
		return;
	} else if (!strncasecmp(buf, "quit", 4)) {
		explicitly_quit = TRUE;
#ifdef DEBUG
	} else if (!strncasecmp(buf, "debug", 5)) {
		//
		// debug
		//
		debug ^= TRUE;
		printf("debug %s\n", debug ? "on" : "off");
		return;
#endif
	}

	sjstr2jstr(newbuf, buf);
	sprintf(linebuf, "%s\r\n", newbuf);
#ifdef DEBUG
	if (debug)
		printf(linebuf);
#endif
	write(sock, linebuf, strlen(linebuf));
}

/****************************************
	ignore list \
****************************************/
void
list_ignore()
{
	printf("%s \033[32mignore:", getnow());
	if (irc_ignore) {
		IGNORE *ip;

			for (ip = irc_ignore; ip; ip = ip->next)
			if (ip->on)
				printf(" %s", ip->nick);
	}
	printf("\033[m\n");
}
