/*
 * config.c
 */

__asm("	text\n	dc.b	'$Id: config.c,v 1.29 1998/11/01 13:29:26 sharl Exp $'\n	even\n");

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>
#include <err.h>
#include <sys/xglob.h>
#include <sys/stat.h>
#include <time.h>
#include <pwd.h>

#include "config.h"
#include "util.h"

static void set_default(void);

/****************************************
	ϐ
****************************************/
char *irc_server = NULL;
char *irc_pass = NULL;
int irc_port = -1;
char *irc_usermode = NULL;
char *irc_nick = NULL;
char *irc_awaynick = NULL;
char *irc_user = NULL;
char *irc_name = NULL;
char *irc_info = NULL;
char *irc_autoquit_message = DEFAULT_AQUIT_MESSAGE;
char *irc_quit_message = DEFAULT_QUIT_MESSAGE;
time_t irc_timeout = DEFAULT_TIMEOUT;
char *irc_keyword = NULL;
char *irc_keyword_bell = NULL;
char *irc_keyword_bold = NULL;
char *irc_autochanops = NULL;
char **irc_autochanop = NULL;
char *irc_autojoin = NULL;
static char *irc_autonicks = NULL;
char **irc_autonick = NULL;
char *irc_autorejoin = NULL;
char *irc_autoreconnect = NULL;
static char *irc_channel_mask = NULL;
char *irc_priv_whois = NULL;

char *irc_isons = NULL;
char **irc_ison = NULL;
ISON *ison_list = NULL;
char *irc_ison_command = NULL;
static char *irc_ison_bell = NULL;
char *ison_bell = NULL;		/* NOTIFY p ADPCM obt@ */
size_t ison_bell_length;
time_t irc_ison_interval = ISON_INTERVAL;
BOOLEAN ison = FALSE;

static char *irc_ignores = NULL;
IGNORE *irc_ignore = NULL;

static char *irc_channels = NULL;
CHANLIST irc_channel[IRC_JOIN_MAX + 1];

char *keyword_bell = NULL;	/* KEYWORD p ADPCM obt@ */
size_t bell_length;			/* ADPCM obt@ */

DIREC directive[] = {
	{RC_AUTOCHANOP,		STR,	&irc_autochanops},
	{RC_AUTOJOIN,		STR,	&irc_autojoin},
	{RC_AUTOQUIT,		STR,	&irc_autoquit_message},
	{RC_AUTORECONNECT,	STR,	&irc_autoreconnect},
	{RC_AUTOREJOIN,		STR,	&irc_autorejoin},
	{RC_AWAYNICK,		STR,	&irc_awaynick},
	{RC_CHANNEL,		STR,	&irc_channels},
	{RC_CHANNEL_MASK,	STR,	&irc_channel_mask},
	{RC_IGNORE,			STR,	&irc_ignores},
	{RC_KEYWORD,		STR,	&irc_keyword},
	{RC_KEYWORD_BELL,	STR,	&irc_keyword_bell},
	{RC_KEYWORD_BOLD,	STR,	&irc_keyword_bold},
//	{RC_LOG_CHANNEL,	STR,	&irc_log_channels},
//	{RC_LOG_DIRECTORY,	STR,	&irc_log_directory},
//	{RC_LOG_FORMAT,		STR,	&irc_log_format},
	{RC_MAILADDRESS,	STR,	&irc_user},
	{RC_NAME,			STR,	&irc_name},
	{RC_NICK,			STR,	&irc_autonicks},
	{RC_ISON,			STR,	&irc_isons},
	{RC_ISON_BELL,		STR,	&irc_ison_bell},
	{RC_ISON_INTERVAL,	NUM,	&irc_ison_interval},
	{RC_PASS,			STR,	&irc_pass},
	{RC_PORT,			NUM,	&irc_port},
	{RC_PRIVWHOIS,		STR,	&irc_priv_whois},
	{RC_QUIT,			STR,	&irc_quit_message},
	{RC_SERVER,			STR,	&irc_server},
	{RC_TIMEOUT,		NUM,	&irc_timeout},
	{RC_USERINFO,		STR,	&irc_info},
	{RC_USERMODE,		STR,	&irc_usermode},
	{NULL},
};

/****************************************
****************************************/
static void
getword(char *keyword, char *value, char *line)
{
	line = skipspace(line);
	if (strtok(line, " \t\n") == NULL) {
		*keyword = *value = '\0';
		return;
	}
	strcpy(keyword, line);
	line = skipspace(line + strlen(keyword) + 1);
	strcpy(value, line);
}

/****************************************
	channel 
	0 ŐI
	-1  IRC_JOIN_MAX z
****************************************/
static int
div_channels()
{
	int count;

	for (count = 0; count < IRC_JOIN_MAX; count++) {
		irc_channel[count].name = NULL;
		irc_channel[count].key = NULL;
	}
	if (irc_channels) {
		char **chan, **clp;

		div_string(irc_channels, &chan);
		for (count = 0, clp = chan; *clp; count++, clp++) {
			char *p;

			p = strchr(*clp, ',');
			if (p) {
				*p = '\0';
				irc_channel[count].key = xstrdup(p + 1);
			}
			irc_channel[count].name = xstrdup(*clp);
		}
		if (count > IRC_JOIN_MAX)
			return -1;
		for (clp = chan; *clp; clp++)
			free(*clp);
		free(chan);
	}
	return 0;
}

/****************************************
	󔒂ŋ؂Ĕz֊i[
	RETURN: 
****************************************/
int
div_string(char *line, char ***array)
{
	char **ptr;
	int count = 0;

	if (!*line)
		return count;

	ptr = *array = (char **)xmalloc(strlen(line) * sizeof(char *) + 1);
	while (*line) {
		char *p, *q;

		*ptr = xmalloc(strlen(line) + 1);
		p = line;
		q = *ptr;
		while (*p && *p != ' ' && *p != '\t')
			*q++ = *p++;
		*q = '\0';
		line = skipspace(line + strlen(*ptr));
		ptr++;
		count++;
	}
	*ptr = NULL;
	return count;
}

/****************************************
	ignore list 
****************************************/
void
init_ignore(char *nick)
{
	int c;

	irc_ignore = xmalloc(sizeof(IGNORE));
	irc_ignore->next = NULL;
	switch (c = *nick) {
		case '-':
		case '+':
			irc_ignore->nick = xstrdup(nick + 1);
			irc_ignore->on = c == '+' ? TRUE : FALSE;
			break;
		default:
			irc_ignore->nick = xstrdup(nick);
			irc_ignore->on = TRUE;
			break;
	}
}

/****************************************
	ignore list ɒǉ
****************************************/
static void
add_ignore(char *nick)
{
	IGNORE *ip;
	int c;

	for (ip = irc_ignore; ip->next; ip = ip->next);
	ip->next = xmalloc(sizeof(IGNORE));
	ip->next->next = NULL;
	switch (c = *nick) {
		case '-':
		case '+':
			ip->next->nick = xstrdup(nick + 1);
			ip->next->on = c == '+' ? TRUE : FALSE;
			break;
		default:
			ip->next->nick = xstrdup(nick);
			ip->next->on = TRUE;
			break;
	}
}

/****************************************
	match  nick  ignore list ύX
****************************************/
void
mod_ignore(char *nick)
{
	IGNORE *ip;
	int c;

	for (ip = irc_ignore; ip; ip = ip->next) {
		switch (c = *nick) {
			case '-':
			case '+':
				if (!strcasecmp(ip->nick, nick + 1)) {
					ip->on = c == '+' ? TRUE : FALSE;
					return;
				}
				break;
			default:
				if (!strcasecmp(ip->nick, nick)) {
					ip->on = TRUE;
					return;
				}
				break;
		}
	}
	add_ignore(nick);
}

/****************************************
	nick  ignore list  ON ɂȂĂ邩
****************************************/
BOOLEAN
chk_ignore(char *nick)
{
	IGNORE *ip;

	if (!irc_ignore)
		return FALSE;
	for (ip = irc_ignore; ip; ip = ip->next) {
		if (!strcasecmp(ip->nick, nick)) {
			return ip->on;
		}
	}
	return FALSE;
}

/****************************************
	configuration file ǂݍ
	I: 0
	ُI: -1
****************************************/
int
ReadConfig()
{
	FILE *rcfp;
	char hdir[BUFSIZ], fname[BUFSIZ], buf[BUFSIZ], keyword[BUFSIZ], value[BUFSIZ];

	{
		char *p = getenv("HOME");
		strcpy(hdir, p ? p : ".");
	}
	_addlastsep(hdir);
	sprintf(fname, "%s" DEFAULT_RC, hdir);
	rcfp = fopen(fname, "r");
	if (rcfp == NULL) {
		sprintf(fname, "%s" DEFAULT_RC2, hdir);
		rcfp = fopen(fname, "r");
	}
	if (rcfp == NULL) {
		set_default();
		return 0;
	}
	while (fgets(buf, sizeof buf, rcfp) != NULL) {
		DIREC *dir;
		BOOLEAN flag = FALSE;

		chop_crlf(buf);
		getword(keyword, value, buf);
		if (*keyword == '#' || *keyword == '/' || *keyword == '\0')
			continue;

		for (dir = directive; dir->name; dir++) {
			if (tolower(*keyword) == tolower(*dir->name)
				&& !strcasecmp(keyword + 1, dir->name + 1)) {
				flag = TRUE;
				switch (dir->type) {
					case STR:
						*(char **)(dir->var) = xmalloc(strlen(value) + 1);
						strcpy(*(char **)(dir->var), value);
						break;
					case NUM:
						*(long *)(dir->var) = atoi(value);
						break;
					default:
						warnx("ReadCondfig: internal error.\n");
						break;
				}
			}
		}
		if (flag == FALSE) {
			errx(EXIT_FAILURE, "%s: Illegal directive: '%s'", fname, keyword);
		}
	}
	fclose(rcfp);

	/* server port round robin  */
	if (irc_server && *irc_server) {
		char *p;

		if ((p = strchr(irc_server, ':')) != NULL) {
			char **port;
			int n;

			*p = '\0';
			n = div_string(p + 1, &port);
			if (port && irc_port < 0) {
				char **pp;

				srand(clock() + time(NULL));
				irc_port = atol(port[rand() % n]);
				for (pp = port; *pp; pp++)
					free(*pp);
				free(port);
			}
		}
	}

	/* channel  */
	if (div_channels() < 0)
		errx(EXIT_FAILURE, "CHANNEL is over %d.", IRC_JOIN_MAX);
	if (irc_channel_mask == NULL)
		irc_channel_mask = DEFAULT_CHANMASK;
	if (irc_autonicks) {
		int n;
		char *p, tmp[512];

		sscanf(irc_autonicks, "%s%n", tmp, &n);
		irc_nick = xstrdup(tmp);
		p = skipspace(irc_autonicks + n);
		div_string(p, &irc_autonick);
	}
	if (irc_autochanops && *irc_autochanops)
		div_string(irc_autochanops, &irc_autochanop);
	if (irc_isons && *irc_isons) {
		char **p;
		int c;

		div_string(irc_isons, &irc_ison);
		for (c = 0, p = irc_ison; *p; c++, p++);
		ison_list = (ISON *)xmalloc(sizeof(ISON) * c);
		for (c = 0, p = irc_ison; *p; c++, p++) {
			ison_list[c].name = *p;
			ison_list[c].on = FALSE;
		}
		irc_ison_command = xmalloc(5 /* 'ISON ' */ + strlen(irc_isons) + 2 /* \r\n */+ 1);
		strcpy(irc_ison_command, "ISON");
		for (p = irc_ison; *p; p++) {
			strcat(irc_ison_command, " ");
			strcat(irc_ison_command, *p);
		}
		strcat(irc_ison_command, "\r\n");
		if (irc_ison_bell) {
			FILE *fp;
			struct stat st;

			if ((fp = fopen(irc_ison_bell, "rb")) == NULL) {
				perror(irc_ison_bell);
				return -1;
			}
			fstat(fileno(fp), &st);
			ison_bell_length = st.st_size;
			ison_bell = xmalloc(ison_bell_length);
			fread(ison_bell, sizeof(char), ison_bell_length, fp);
			fclose(fp);
		}
	}

	if (irc_ignores && *irc_ignores) {
		char **ign, **ignnicks = NULL;

		div_string(irc_ignores, &ignnicks);
		if ((ign = ignnicks) != NULL) {
			init_ignore(*ign);
			for (ign++; *ign; ign++)
				add_ignore(*ign);
			for (ign = ignnicks; *ign; ign++)
				free(*ign);
			free(ignnicks);
		}
	}

	if (irc_keyword_bell) {
		FILE *fp;
		struct stat st;

		if ((fp = fopen(irc_keyword_bell, "rb")) == NULL) {
			perror(irc_keyword_bell);
			return -1;
		}
		fstat(fileno(fp), &st);
		bell_length = st.st_size;
		keyword_bell = xmalloc(bell_length);
		fread(keyword_bell, sizeof(char), bell_length, fp);
		fclose(fp);
	}

	set_default();
	return 0;
}

/****************************************
	ftHglɐݒ
****************************************/
static void
set_default()
{
	/* port  */
	if (irc_port < 0)
		irc_port = DEFAULT_PORT;

	/* NICK */
	if (irc_nick == NULL)
		if ((irc_nick = getenv("USER")) == NULL)
			irc_nick = getenv("LOGNAME");

	/* USER p mail address */
	if (irc_user == NULL) {
#define MAXDOMAINNAME	(256)
		char *domain;

		domain = xmalloc(MAXDOMAINNAME);
		if (!getdomainname(domain, MAXDOMAINNAME - 1)) {
			if (irc_nick) {
				irc_user = xmalloc(strlen(irc_nick) + 1 /* '@' */ + strlen(domain) + 1);
				strcpy(irc_user, irc_nick);
				strlwr(irc_user);
				strcat(irc_user, "@");
				strcat(irc_user, domain);
			}
		}
		free(domain);
	}

	/* USER p real name */
	if (irc_name == NULL) {
		if (irc_nick) {
			struct passwd *passwd;

			passwd = getpwnam(irc_nick);
			if (*passwd->pw_gecos)
				irc_name = xstrdup(passwd->pw_gecos);
		}
	}

	/* user information */
	if (irc_info == NULL)
		irc_info = DEFAULT_USERINFO;
}
