/*
 * config.h
 *
 * $Id: config.h,v 1.28 1999/04/21 00:34:17 sharl Exp $
 */
#ifndef __config_h__
#define __config_h__

#include <sys/types.h>

#define AUTHOR	"Kazuya 'Sharl' Masuda <sharl@hauN.org>"

/* avoid getopt.c does not include string.h */
#define __GNU_LIBRARY__

#define DEFAULT_RC				"." PROGNAME "rc"
#define DEFAULT_RC2				PROGNAME "rc"
#define DEFAULT_CHANMASK		"*.jp"
#define DEFAULT_USERINFO		"No user information given."
#define DEFAULT_QUIT_MESSAGE	"I Quit"
#define DEFAULT_AQUIT_MESSAGE	"Inactive timeout"

#define DEFAULT_PORT		(6667)
#define DEFAULT_TIMEOUT		(-1)	/* timeout Ȃ */
#define ISON_INTERVAL		(60)

#define IRC_JOIN_MAX		(10)
#define IRC_CHANNEL_MAX		(200)
#define IRC_MESSAGE_MAX		(512)

#define RC_AUTOCHANOP		"AUTO-CHANOP"
#define RC_AUTOJOIN			"AUTO-JOIN"
#define RC_AUTOQUIT			"AUTO-QUIT"
#define RC_AUTORECONNECT	"AUTO-RECONNECT"
#define RC_AUTOREJOIN		"AUTO-REJOIN"
#define RC_AWAYNICK			"AWAY-NICK"
#define RC_CHANNEL			"CHANNEL"
#define RC_CHANNEL_MASK		"CHANNEL-MASK"
#define RC_IGNORE			"IGNORE"
#define RC_ISON				"NOTIFY"
#define RC_ISON_BELL		"NOTIFY-BELL"
#define RC_ISON_INTERVAL	"NOTIFY-INTERVAL"
#define RC_LOG_CHANNEL		"LOG-CHANNEL"
#define RC_LOG_DIRECTORY	"LOG-DIRECTORY"
#define RC_LOG_FORMAT		"LOG-FORMAT"
#define RC_USERMODE			"USERMODE"
#define RC_NAME				"NAME"
#define RC_NICK				"NICK"
#define RC_KEYWORD			"KEYWORD"
#define RC_KEYWORD_BELL		"KEYWORD-BELL"
#define RC_KEYWORD_BOLD		"KEYWORD-BOLD"
#define RC_PASS				"PASS"
#define RC_PORT				"PORT"
#define RC_PRIVWHOIS		"PRIV-WHOIS"
#define RC_QUIT				"QUIT"
#define RC_SERVER			"SERVER"
#define RC_TIMEOUT			"TIMEOUT"
#define RC_MAILADDRESS		"MAIL"
#define RC_USERINFO			"USERINFO"

typedef enum {
	FALSE,
	TRUE,
} BOOLEAN;

typedef enum {
	STR,
	NUM,
} TYPE;

typedef struct {
	char *name;
	TYPE type;
	void *var;
} DIREC;

typedef struct {
	char *name;
	BOOLEAN on;
} ISON;

typedef struct IGNORE {
	struct IGNORE *next;
	char *nick;
	BOOLEAN on;	// TRUE: invisible, FALSE: visible
} IGNORE;

typedef struct {
	char *name;
	char *key;
} CHANLIST;

int div_string(char *, char ***);
void init_ignore(char *);
void mod_ignore(char *);
BOOLEAN chk_ignore(char *);
int ReadConfig(void);

extern char *__progname;

extern char *irc_server;
extern char *irc_pass;
extern int irc_port;
extern char *irc_usermode;
extern char *irc_nick;
extern char *irc_awaynick;
extern char *irc_user;
extern char *irc_name;
extern char *irc_info;
extern char *irc_autoquit_message;
extern char *irc_quit_message;
extern time_t irc_timeout;
extern char *irc_keyword;
extern char *irc_keyword_bell;
extern char *irc_keyword_bold;
extern char *irc_autochanops;
extern char **irc_autochanop;
extern char *irc_autojoin;
extern char **irc_autonick;
extern char *irc_autoreconnect;
extern char *irc_autorejoin;
extern CHANLIST irc_channel[];
extern char *irc_priv_whois;

extern char *irc_isons;
extern char **irc_ison;
extern ISON *ison_list;
extern char *irc_ison_command;
extern char *irc_ison_bell;
extern char *ison_bell;
extern size_t ison_bell_length;
extern time_t irc_ison_interval;
extern BOOLEAN ison;

extern IGNORE *irc_ignore;

extern char *keyword_bell;
extern size_t bell_length;
extern DIREC directive[];

#ifdef DEBUG
extern BOOLEAN debug;
#endif

#endif
