/*
 * irc.c
 */

__asm("	text\n	dc.b	'$Id: irc.c,v 1.45 1998/10/11 08:36:01 sharl Exp $'\n	even\n");

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#define __IOCS_INLINE__
#include <iocslib.h>

#include "config.h"
#include "ircdef.h"
#include "irc.h"
#include "action.h"
#include "ctcp.h"
#include "command.h"
#include "channel.h"
#include "util.h"
#include "kanji.h"

BOOLEAN ignore_long_cmd = FALSE;

/****************************************
	T[õbZ[W
****************************************/
static BOOLEAN
irc_fromserver(int sock, char *buf)
{
	char newbuf[1024], tmpbuf[1024];
	char chan[512], chanbuf[512];
	char nick[512];
	int num, len;

	if (sscanf(buf, "%*s %d %s %n", &num, nick, &len)) {
#ifdef DEBUG
		if (debug)
			puts(buf);
#endif
		/* ɂȂ邩? */
		if (ignore_long_cmd
			&& (num == RPL_LIST || num == RPL_WHOREPLY || num == RPL_NAMREPLY))
			return TRUE;

		switch (num){
			case RPL_WELCOME:			/* 1 */
			case RPL_YOURHOST:			/* 2 */
			case RPL_CREATED:			/* 3 */
			case RPL_LUSERCLIENT:		/* 251 */
			case RPL_LUSERME:			/* 255 */
			case RPL_ADMINME:			/* 256 */
			case RPL_ADMINLOC1:			/* 257 */
			case RPL_ADMINLOC2:			/* 258 */
			case RPL_ADMINEMAIL:		/* 259 */
			case RPL_USERHOST:			/* 302 */
			case RPL_INFO:				/* 371 */
			case RPL_MOTD:				/* 372 */
			case RPL_MOTDSTART:			/* 375 */
			case RPL_YOUREOPER:			/* 381 */
			case RPL_YOURESERVICE:		/* 383 */
				jstr2sjstr(newbuf, buf + len + 1);
				printf("%s \033[31m%s\033[m\n", getnow(), newbuf);
				break;
			case RPL_MYINFO:			/* 4 */
			case RPL_LISTSTART:			/* 321 */
				printf("%s \033[31m%s\033[m\n", getnow(), buf + len);
				break;

			case RPL_ENDOFWHO:			/* 315 */
				ignore_long_cmd = FALSE;
				/* THROUGH */
			case RPL_TRACELINK:			/* 200 */
			case RPL_TRACECONNECTING:	/* 201 */
			case RPL_TRACEHANDSHAKE:	/* 202 */
			case RPL_TRACEUNKNOWN:		/* 203 */
			case RPL_TRACEOPERATOR:		/* 204 */
			case RPL_TRACEUSER:			/* 205 */
			case RPL_TRACESERVER:		/* 206 */
			case RPL_TRACESERVICE:		/* 207 */
			case RPL_TRACENEWTYPE:		/* 208 */
			case RPL_TRACECLASS:		/* 209 */
			case RPL_TRACERECONNECT:	/* 210 */

			case RPL_STATSLINKINFO:		/* 211 */
			case RPL_STATSCOMMANDS:		/* 212 */
			case RPL_STATSCLINE:		/* 213 */
			case RPL_STATSNLINE:		/* 214 */
			case RPL_STATSILINE:		/* 215 */
			case RPL_STATSKLINE:		/* 216 */
			case RPL_STATSYLINE:		/* 218 */
			case RPL_SERVICEINFO:		/* 231 */
			case RPL_ENDOFSERVICES:		/* 232 */
			case RPL_SERVICE:			/* 233 */
			case RPL_SERVLIST:			/* 234 */
			case RPL_SERVLISTEND:		/* 235 */
			case RPL_STATSLLINE:		/* 241 */
			case RPL_STATSUPTIME:		/* 242 */
			case RPL_STATSOLINE:		/* 243 */
			case RPL_STATSHLINE:		/* 244 */
			case RPL_STATSSLINE:		/* 245 */
			case RPL_STATSPING:			/* 246 */
			case RPL_STATSDEFINE:		/* 248 */
			case RPL_TRACELOG:			/* 261 */
			case RPL_WHOREPLY:			/* 352 */
				jstr2sjstr(newbuf, buf + len);
				printf("%s \033[31m*** %s\033[m\n", getnow(), newbuf);
				break;
			case RPL_ENDOFSTATS:		/* 219 */
			case RPL_WHOISOPERATOR:		/* 313 */
			case RPL_ENDOFLINKS:		/* 365 */
			case RPL_BANLIST:			/* 367 */
			case RPL_ENDOFBANLIST:		/* 368 */
				sscanf(buf + len, "%s :%[^\r\n]", tmpbuf, newbuf);
				printf("%s \033[31m*** %s: %s\033[m\n", getnow(), tmpbuf, newbuf);
				break;
			case RPL_UMODEIS:			/* 221 */
				printf("%s \033[31m*** Mode for you is %s\033[m\n", getnow(), buf + len);
				break;

			case RPL_LISTEND:			/* 323 */
				ignore_long_cmd = FALSE;
				/* THROUGH */
			case RPL_STATSDEBUG:		/* 249 */
			case RPL_USERSSTART:		/* 392 */
			case RPL_USERS:				/* 393 */
			case RPL_ENDOFUSERS:		/* 394 */
			case RPL_NOUSERS:			/* 395 */
				printf("%s \033[31m*** %s\033[m\n", getnow(), buf + len + 1);
				break;
			case RPL_LUSEROP:			/* 252 */
			case RPL_LUSERUNKNOWN:		/* 253 */
			case RPL_LUSERCHANNELS:		/* 254 */
				{
					unsigned int number;

					sscanf(buf + len, "%d :%[^\r\n]", &number, tmpbuf);
					printf("%s \033[31m%d %s\033[m\n", getnow(), number, tmpbuf);
				}
				break;
			case RPL_TRACEEND:			/* 262 */
			case RPL_LINKS:				/* 364 */
				sscanf(buf + len, "%s %s :%[^\r\n]", tmpbuf, chan, newbuf);
				printf("%s \033[31m*** %s %s: %s\033[m\n", getnow(), tmpbuf, chan, newbuf);
				break;
			case RPL_AWAY:				/* 301 */
				{
					int n;

					sscanf(buf + len, "%s :%n", chan, &n);
					jstr2sjstr(tmpbuf, buf + len + n);
					printf("%s \033[31m*** %s: \033[35maway: %s\033[m\n",
						   getnow(), chan, tmpbuf);
				}
				break;
			case RPL_ISON:				/* 303 */
				if (ison)
					notify(buf + len);
				else
					printf("%s \033[31mFollowing people(s) are on: %s\033[m\n",
						   getnow(), buf + len + 1);
				break;
			case RPL_UNAWAY:			/* 305 */
			case RPL_NOWAWAY:			/* 306 */
				printf("%s \033[31m%s\033[m\n", getnow(), buf + len + 1);
				if (irc_awaynick) {
					if (num == RPL_UNAWAY)
						unaway(sock, nick);
					else
						nowaway(sock, nick);
				}
				break;
			case RPL_WHOISUSER:			/* 311 */
			case RPL_WHOWASUSER:		/* 314 */
				{
					int n;

					sscanf(buf + len, "%s %n", tmpbuf, &n);
					jstr2sjstr(newbuf, buf + len + n);
					printf("%s \033[31m*** %s: %s\033[m\n", getnow(), tmpbuf, newbuf);
				}
				break;
			case RPL_WHOISSERVER:		/* 312 */
				{
					char comm[256];

					sscanf(buf + len, "%s %s :%[^\r\n]", tmpbuf, newbuf, comm);
					printf("%s \033[31m*** %s: %s [%s]\033[m\n",
						   getnow(), tmpbuf, newbuf, comm);
				}
				break;
			case RPL_WHOISIDLE:			/* 317 */
				{
					int t, n;

					sscanf(buf + len, "%s %d :%n", tmpbuf, &t, &n);
					printf("%s \033[31m*** %s: %d %s\033[m\n",
						   getnow(), tmpbuf, t, buf + len + n);
				}
				break;
			case RPL_WHOISCHANNELS:		/* 319 */
			case RPL_ENDOFWHOWAS:		/* 369 */
				{
					int n;

					sscanf(buf + len, "%s :%n", chan, &n);
					jchan2sjchan(chanbuf, chan);
					jstr2sjstr(tmpbuf, buf + len + n);
					printf("%s \033[31m*** %s: %s\033[m\n", getnow(), chanbuf, tmpbuf);
				}
				break;
			case RPL_LIST:				/* 322 */
				{
					int t, n;

					sscanf(buf + len, "%s %d :%n", chan, &t, &n);
					jchan2sjchan(chanbuf, chan);
					jstr2sjstr(tmpbuf, buf + len + n);
					printf("%s \033[31m*** %s: %d: %s\033[m\n", getnow(), chanbuf, t, tmpbuf);
				}
				break;
			case RPL_CHANNELMODEIS:		/* 324 */
				{
					CHANSTAT *csp;

					sscanf(buf + len, "%s +%[^\r\n]", chan, tmpbuf);
					jchan2sjchan(chanbuf, chan);
					csp = getchanstat(chanbuf);
					if (!csp || csp->donemodewithjoined || *tmpbuf != ' ')
						printf("%s \033[31m*** MODE %s +%s\033[m\n", getnow(), chanbuf, tmpbuf);
					if (csp)
						csp->donemodewithjoined = TRUE;
				}
				break;
			case RPL_NOTOPIC:			/* 331 */
			case RPL_TOPIC:				/* 332 */
				sscanf(buf + len, "%s :%[^\r\n]", chan, tmpbuf);
				jchan2sjchan(chanbuf, chan);
				jstr2sjstr(newbuf, tmpbuf);
				if (num == RPL_NOTOPIC)
					printf("%s \033[31m*** %s: %s\033[m\n", getnow(), chanbuf, tmpbuf);
				else {
					printf("%s \033[31m*** Topic for %s: %s\033[m\n",
						   getnow(), chanbuf, newbuf);
					set_topic(chanbuf, newbuf);
				}
				break;
			case RPL_INVITING:			/* 341 */
				jstr2sjstr(newbuf, buf + len);
				printf("%s \033[31mINVITE %s\033[m\n", getnow(), newbuf);
				break;
			case RPL_SUMMONING:			/* 342 */
			case RPL_REHASHING:			/* 382 */
			case RPL_TIME:				/* 391 */
				sscanf(buf + len, "%s :%[^\r\n]", tmpbuf, newbuf);
				printf("%s \033[31m%s: %s\033[m\n", getnow(), tmpbuf, newbuf);
				break;
			case RPL_VERSION:			/* 351 */
				printf("%s \033[31mVERSION %s\033[m\n", getnow(), buf + len);
				break;
			case RPL_NAMREPLY:			/* 353 */
				auto_oper1(sock, buf + len);
				break;
			case RPL_ENDOFNAMES:		/* 366 */
				ignore_long_cmd = FALSE;
				if (--names_num <= 0) {
					show_namreply = TRUE;
					names_num = 0;
				}
#ifdef DEBUG
				if (debug)
					printf("names_num %d\n", names_num);
#endif
				break;

			case RPL_ENDOFWHOIS:		/* 318 */
			case RPL_ENDOFINFO:			/* 374 */
			case RPL_ENDOFMOTD:			/* 376 */
			case ERR_NOTEXTTOSEND:		/* 412 */
				break;

			case ERR_NOSUCHNICK:		/* 401 */
			case ERR_NOSUCHSERVER:		/* 402 */
			case ERR_NOSUCHCHANNEL:		/* 403 */
			case ERR_CANNOTSENDTOCHAN:	/* 404 */
			case ERR_TOOMANYCHANNELS:	/* 405 */
			case ERR_WASNOSUCHNICK:		/* 406 */
			case ERR_TOOMANYTARGETS:	/* 407 */
			case ERR_NOTOPLEVEL:		/* 413 */
			case ERR_WILDTOPLEVEL:		/* 414 */
			case ERR_UNKNOWNCOMMAND:	/* 421 */
			case ERR_NOADMININFO:		/* 423 */
			case ERR_ERRONEUSNICKNAME:	/* 432 */
			case ERR_NICKCOLLISION:		/* 436 */
			case ERR_UNAVAILRESOURCE:	/* 437 */
			case ERR_NOTONCHANNEL:		/* 442 */
			case ERR_NOLOGIN:			/* 444 */
			case ERR_NEEDMOREPARAMS:	/* 461 */
			case ERR_KEYSET:			/* 467 */
			case ERR_CHANNELISFULL:		/* 471 */
			case ERR_UNKNOWNMODE:		/* 472 */
			case ERR_INVITEONLYCHAN:	/* 473 */
			case ERR_BANNEDFROMCHAN:	/* 474 */
			case ERR_BADCHANNELKEY:		/* 475 */
			case ERR_CHANOPRIVSNEEDED:	/* 482 */
				sscanf(buf + len, "%s :%[^\r\n]", chan, newbuf);
				jchan2sjchan(chanbuf, chan);
				printf("%s \033[32m%s: %s\033[m\n", getnow(), chanbuf, newbuf);
				break;
			case ERR_NOORIGIN:			/* 409 */
			case ERR_NORECIPIENT:		/* 411 */
			case ERR_NOMOTD:			/* 422 */
			case ERR_FILEERROR:			/* 424 */
			case ERR_NONICKNAMEGIVEN:	/* 431 */
			case ERR_SUMMONDISABLED:	/* 445 */
			case ERR_USERSDISABLED:		/* 446 */
			case ERR_NOTREGISTERED:		/* 451 */
			case ERR_ALREADYREGISTRED:	/* 462 */
			case ERR_NOPERMFORHOST:		/* 463 */
			case ERR_PASSWDMISMATCH:	/* 464 */
			case ERR_YOUREBANNEDCREEP:	/* 465 */
			case ERR_NOPRIVILEGES:		/* 481 */
			case ERR_CANTKILLSERVER:	/* 483 */
			case ERR_RESTRICTED:		/* 484 */
			case ERR_NOOPERHOST:		/* 491 */
			case ERR_UMODEUNKNOWNFLAG:	/* 501 */
			case ERR_USERSDONTMATCH:	/* 502 */
				printf("%s \033[32m%s\033[m\n", getnow(), buf + len + 1);
				break;
			case ERR_NOSUCHSERVICE:		/* 408 */
			case ERR_BADMASK:			/* 415 */
			case ERR_NICKNAMEINUSE:		/* 433 */
			case ERR_NOCHANMODES:		/* 477 */
				sscanf(buf + len, "%s :%[^\r\n]", tmpbuf, newbuf);
				printf("%s \033[32m%s: %s\033[m\n", getnow(), tmpbuf, newbuf);
				return FALSE;
			case ERR_TOOMANYMATCHES:	/* 416 */
			case ERR_USERNOTINCHANNEL:	/* 441 */
			case ERR_USERONCHANNEL:		/* 443 */
				sscanf(buf + len, "%s %s :%[^\r\n]", tmpbuf, chan, newbuf);
				jchan2sjchan(chanbuf, chan);
				printf("%s \033[32m%s %s: %s\033[m\n", getnow(), tmpbuf, newbuf, chanbuf);
				break;
			default:
				jstr2sjstr(newbuf, buf + len);
				printf("%s \033[36m%d\033[m %s", getnow(), num, newbuf);
				break;
		}
	} else {
#ifdef DEBUG
		if (debug)
			puts(buf);
#endif
		sscanf(buf, "%*s %s %n", tmpbuf, &len);
		if (!strcmp(tmpbuf, "NOTICE")) {
			sscanf(buf + len, "%*s :%[^\r\n]", tmpbuf);
			printf("%s \033[31m*** %s\033[m\n", getnow(), tmpbuf);
		} else if  (!strcmp(tmpbuf, "WALLOPS"))
			printf("%s \033[31m*** %s\033[m\n", getnow(), buf + len + 1);
		else
			printf("%s \033[36m%s\033[m\n", getnow(), buf);
	}
	return TRUE;
}

/****************************************
	[ŨbZ[W
****************************************/
static void
irc_fromuser(char *buf)
{
	char newbuf[1024];
	char from[512];
	char comm[512];
	char to[512];
	int len;

#ifdef DEBUG
	if (debug)
		puts(buf);
#endif
	sscanf(buf, "%s %s %s %n", from, comm, to, &len);
	if (!strcmp(from, irc_nick) && !strcmp(to, irc_nick) && !strcmp(comm, "MODE")) {
		printf("%s \033[31m*** Your new mode is set: %s\033[m\n", getnow(), buf + len + 1);
	} else {
		jstr2sjstr(newbuf, buf);
		printf("%s \033[36m%s\033[m\n", getnow(), newbuf);
	}
}

/****************************************
	NOTICE, PRIVMSG ł̉ʂւ̕\

	chan: SJIS
	rest: JIS
****************************************/
static void
display(char *nick, char *chan, char *rest, BOOLEAN isignore)
{
	char newbuf[1024];

	if (!strcasecmp(irc_nick, chan)) {
		/* l */
		CHANSTAT *csp;

		if (isignore && chk_ignore(nick))
			return;
		jstr2sjstr(newbuf, rest + 1);
		printf("%s =%s:%s= \033[%dm%s\033[m\n",
			   getnow(), chan, nick, isignore ? 33 : 37, newbuf);
		if ((csp = getchanstat(nick)) == NULL)
			join_chanlist(nick, FALSE);
	} else {
		/* `l */
		if (isignore && (chk_ignore(nick) || chk_ignore(chan)))
			return;
		jstr2sjstr(newbuf, rest + 1);
		if (irc_keyword && strstr(newbuf, irc_keyword)) {
			if (keyword_bell)
				_iocs_adpcmout(keyword_bell, 0x0403 /* 15.6KHz, stereo */,
							   bell_length);
			else
				putchar('\a');
			if (irc_keyword_bold) {
				printf("%s <%s:%s> \033[37m%s\033[m\n",
					   getnow(), chan, nick, newbuf);
				return;
			}
		}
		printf("%s <%s:%s> \033[%dm%s\033[m\n",
			   getnow(), chan, nick, isignore ? 33 : 37, newbuf);
	}
}

/****************************************
	s
****************************************/
BOOLEAN
irc_parseline(int sock, char *buf)
{
	const CMD *cmd;
	char newbuf[1024];
	char chanbuf[1024];
	char nick[512] = {0};
	char chan[512] = {0};
	char comm[512] = {0};
	char rest[512] = {0};

	if (*buf == ':') {
		sscanf(buf + 1, "%s", newbuf);
		if (!strncmp(irc_server, newbuf, strlen(newbuf))
			|| !strncmp(newbuf, irc_server, strlen(irc_server))
			|| (!strchr(newbuf, '!') && strchr(newbuf, '.'))
		   ) {	/* T[õbZ[W */
			return irc_fromserver(sock, buf + 1);
		} else if (strchr(buf, '!') == NULL) {	/* [ŨbZ[W */
			irc_fromuser(buf + 1);
		} else {	/* ̑̃[ŨbZ[W */
			int len;

#ifdef DEBUG
			if (debug)
				puts(buf);
#endif
			sscanf(buf + 1, "%[^!]%*s %s %n", nick, comm, &len);

			buf += len + 1;
			if (*buf == ':')	/* :hoho!~hoho@10.0.0.1 JOIN :#scot */
				sscanf(buf + 1, "%[^\a\r\n]", chan);
			else				/* :hoho!~hoho@10.0.0.1 PRIVMSG #scot :hoe- */
				sscanf(buf, " %s %[^\r\n]", chan, rest);

			jchan2sjchan(chanbuf, chan);
#ifdef DEBUG
			if (debug) {
				printf("nick [%s]\n", nick);
				printf("comm [%s]\n", comm);
				printf("chan [%s]\n", chanbuf);
				printf("rest [%s]\n", rest);
			}
#endif
			cmd = in_word_set(comm, strlen(comm));
			switch (cmd->cmd) {
				case T_INVITE:
					if (*(rest + 1) == '#' || *(rest + 1) == '&') {
						jchan2sjchan(newbuf, rest + 1);
						printf("%s \033[31m*** %s invites you to %s\033[m\n",
							   getnow(), nick, newbuf);
						if (irc_autojoin) {
							char line[1024];

							printf("%s \033[32mauto join to %s\033[m\n", getnow(), newbuf);
							sprintf(line, "JOIN %s\r\n", rest + 1);
							write(sock, line, strlen(line));
						}
					}
					break;
				case T_JOIN:
					printf("%s \033[35m%s has joined %s\033[m\n", getnow(), nick, chanbuf);
					if (!strcmp(irc_nick, nick)) {
						char line[1024];

						join_chanlist(chanbuf, TRUE);
						sprintf(line, "MODE %s\r\n", chan);
						write(sock, line, strlen(line));
					} else {
						auto_oper2(sock, chanbuf, nick);
					}
					break;
				case T_KICK:
					apply_kick(sock, nick, chan, rest);
					break;
				case T_MODE:
					printf("%s \033[31m*** New mode for %s set by %s: %s\033[m\n",
						   getnow(), chanbuf, nick, rest);
					apply_mode(sock, chan);
					break;
				case T_NICK:
					printf("%s \033[31m*** %s is now known as %s\033[m\n",
						   getnow(), nick, chan);
					apply_nick(sock, nick, chan);
					break;
				case T_PART:
					printf("%s \033[35m%s has parted %s\033[m\n", getnow(), nick, chanbuf);
					if (!strcmp(irc_nick, nick))
						part_chanlist(chanbuf);
					break;
				case T_QUIT:
					printf("%s \033[35m%s has left IRC (%s)\033[m\n", getnow(), nick, chanbuf);
					break;
				case T_TOPIC:
					jstr2sjstr(newbuf, rest + 1);
					printf("%s \033[31m*** New topic on %s set by %s: %s\033[m\n",
						   getnow(), chanbuf, nick, newbuf);
					set_topic(chanbuf, newbuf);
					break;

				case T_NOTICE:
					if (*(rest + 1) == '\001')
						ctcp_action(nick, rest + 1);
					else
						display(nick, chanbuf, rest, FALSE);
					break;

				case T_PRIVMSG:
					if (*(rest + 1) == '\001')
						ctcp_from(sock, nick, chanbuf, rest + 1);
					else
						display(nick, chanbuf, rest, TRUE);
					break;

				default:
					printf("%s \033[36mUnsupport command %s\033[m\n", getnow(), comm);
					break;
			}
		}
#ifdef DEBUG
	} else {
		if (debug)
			printf("\033[46mWhat? %s\033[m\n", buf);
#endif
	}
	return TRUE;
}
