/*
 * util.c
 */

__asm("	text\n	dc.b	'$Id: util.c,v 1.7 1998/10/11 08:34:02 sharl Exp $'\n	even\n");

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <err.h>

#include "util.h"

/****************************************
	ی@\ malloc
****************************************/
void *
xmalloc(size_t len)
{
	void *p;

	if ((p = malloc(len)) == NULL)
		errx(EXIT_FAILURE, "malloc");
	return p;
}

/****************************************
	ی@\ realloc
****************************************/
void *
xrealloc(void *p, size_t len)
{
	if ((p = realloc(p, len)) == NULL)
		errx(EXIT_FAILURE, "realloc");
	return p;
}

/****************************************
	ی@\ strdup
****************************************/
char *
xstrdup(const char *str)
{
	char *p;

	p = xmalloc(strlen(str) + 1);
	strcpy(p, str);
	return p;
}

/****************************************
	ݎ擾
****************************************/
char *
getnow()
{
	static char buf[5 + 1];
	struct tm *tim;
	time_t t;

	t = time(NULL);
	tim = localtime(&t);
	sprintf(buf, "%02d:%02d", tim->tm_hour, tim->tm_min);
	return buf;
}

/****************************************
	case insensitive strstr()
****************************************/
char *
strcasestr(const char *s, const char *find)
{
	char c, sc;
	size_t len;

	if ((c = *find++) != 0) {
		len = strlen(find);
		do {
			do {
				if ((sc = *s++) == 0)
					return NULL;
			} while (tolower(sc) != tolower(c));
		} while (strncasecmp(s, find, len) != 0);
		s--;
	}
	return (char *)s;
}

/****************************************
	擪̋󔒕XLbv
****************************************/
char *
skipspace(char *line)
{
	char *p;

	for (p = line; *p; p++) {
		if (*p != ' ' && *p != '\t')
			break;
	}
	return p;
}

/****************************************
	s CRLF 폜
****************************************/
void
chop_crlf(char *buf)
{
	int pos = strlen(buf) - 1;

	if (*(buf + pos) == '\n')
		*(buf + pos) = '\0';
	if (*(buf + pos - 1) == '\r')
		*(buf + pos - 1) = '\0';
}
